require 'curb'


module Esteem
  class Alias
    attr_reader :success

    PREFIXES = %w[
      logs-atop
      logs-denim    logs-denim-capture
      logs-rivet    logs-rivet-500
      logs-seam     logs-seam-access     logs-seam-newrelic
      logs-cobalt   logs-cobalt-access   logs-cobalt-newrelic
      logs-carder
      logs-franz
      logs-rollway-skinny logs-rollway-acid
      logs-openstack logs-openstack-nova logs-openstack-cinder
    ]


    def initialize month:, year:, host:
      @success = false
      begin
        perform month, year, host
        @success = true
      rescue
      end
    end



  private

    def perform month, year, host
      (1..31).each do |day|
        suffix = '%d.%02d.%02d' % [ year, month, day ]

        PREFIXES.each do |logger|

          Curl.post "#{host}/_aliases", {
            actions: [
              {
                add: {
                  alias: "logger-#{suffix}",
                  index: "#{logger}-#{suffix}"
                }
              }
            ]
          }

        end
      end
    end

  end
end